﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip
Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private bc,bc1 As BitmapCreator
	Dim nativeMe As JavaObject
	Dim bm1, bm2 As Bitmap
	Private ImageView1, ImageView2 As ImageView
	Dim anchopantalla, altopantalla As Int
End Sub

Public Sub Initialize
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("main")
	Root.Color=Colors.LightGray
	nativeMe.InitializeContext
	
	anchopantalla=498
	altopantalla=382
	
	Dim img As B4XBitmap = LoadBitmap(File.DirAssets, "33rfn.png")
	bc.Initialize(anchopantalla, altopantalla)
	bc.CopyPixelsFromBitmap(img)
	bc.DrawCircle(150,100,8,Colors.Red,True,1) 'DRAW POINT RED
	bm1=bc.Bitmap
	ImageView1.Bitmap=bm1
	ImageView1.SetLayout(0,0,100%x,50%y)

	'PROCESS TRANSFORMATION + CROP + RESIZE IMAGE TO FIT 
	Dim source() As Float = Array As Float(144.0, 1.0, 499.0, 160.0, 373.0, 385.0, 0.0, 210.0)
	Dim destination() As Float = Array As Float(0, 0, anchopantalla, 0, anchopantalla, altopantalla, 0, altopantalla)
	bm2 = nativeMe.RunMethod("perspectiveTransformationCropAndFit", Array(bm1, source, destination))

	'ORIGINAL PROCESS --> https://www.b4x.com/android/forum/threads/perspectivetransformation.73984/#content
	'bm2 = nativeMe.RunMethod("perspectiveTransformation", Array(bm1, source))

	'DRAW POINT GREEN WITH ---> WhereDidItComeFrom
	Dim X As Int = 150
	Dim Y As Int = 100
	Dim ToXY() As Float = Array As Float(x, y)
	Dim FromXY() As Float = WhereDidItComeFrom(source, destination, ToXY)
	Log(ToXY(0) & TAB & ToXY(1) & TAB & FromXY(0) & TAB & FromXY(1))


	bc1.Initialize(anchopantalla, altopantalla)
	bc1.CopyPixelsFromBitmap(bm2)
	bc1.DrawCircle(FromXY(0),FromXY(1),8,Colors.green,True,1)
	ImageView2.Bitmap=bc1.Bitmap
	ImageView2.SetLayout(0,50%y,100%x,50%y)
End Sub

Sub WhereDidItComeFrom(src() As Float, dst() As Float, dstxy() As Float) As Float()
	'dst must be rectangle with top-left = (0, 0)
	Dim dstleft As Float = dst(0)
	Dim dsttop As Float = dst(1)
	Dim dstright As Float = dst(4)
	Dim dstbottom As Float = dst(5)
	Dim dstwidth As Float = dstright - dstleft
	Dim dstheight As Float = dstbottom - dsttop
 
	Dim dstx As Float = dstxy(0)
	Dim dsty As Float = dstxy(1)
 
	Dim HowMuchRight As Float = (dstx - dstleft) / dstwidth
	Dim HowMuchLeft As Float = 1 - HowMuchRight
	Dim HowMuchBottom As Float = (dsty - dsttop) / dstheight
	Dim HowMuchTop As Float = 1 - HowMuchBottom
 
	'if we are lucky then these should sum to 1.0
	Dim HowMuchTopLeft As Float = HowMuchTop * HowMuchLeft
	Dim HowMuchTopRight As Float = HowMuchTop * HowMuchRight
	Dim HowMuchBottomLeft As Float = HowMuchBottom * HowMuchLeft
	Dim HowMuchBottomRight As Float = HowMuchBottom * HowMuchRight
 
	Dim srcx As Float = src(0) * HowMuchTopLeft _
                      + src(2) * HowMuchTopRight _
                      + src(4) * HowMuchBottomRight _
                      + src(6) * HowMuchBottomLeft
 
	Dim srcy As Float = src(1) * HowMuchTopLeft _
                      + src(3) * HowMuchTopRight _
                      + src(5) * HowMuchBottomRight _
                      + src(7) * HowMuchBottomLeft
               
	Return Array As Float(srcx, srcy)
End Sub